

#include "debug.h"

#define I2CPORT     GPIOB   //IO  ӿ
#define I2C_SCL     GPIO_Pin_8  //IOӿ
#define I2C_SDA     GPIO_Pin_9  //IOӿ
#define RxAdderss   0x02

#define Size   6

volatile u8 TxData[Size] = { 0x01, 0x02, 0x03, 0x04, 0x05, 0x06 };

volatile uint16_t slave_send_len = 0;


void I2C1_Init(u32 bound, u16 address) {
    GPIO_InitTypeDef GPIO_InitStructure;
    I2C_InitTypeDef I2C_InitTSturcture;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOB | RCC_APB2Periph_AFIO, ENABLE);
    GPIO_PinRemapConfig(GPIO_Remap_I2C1, ENABLE); //ӳ书ܣPB8PB9ӳΪI2C1
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_I2C1, ENABLE);
    GPIO_InitStructure.GPIO_Pin = I2C_SCL | I2C_SDA;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init( I2CPORT, &GPIO_InitStructure);

    I2C_DeInit(I2C1);
    I2C_InitTSturcture.I2C_ClockSpeed = bound;     //I2C
    I2C_InitTSturcture.I2C_Mode = I2C_Mode_I2C;    //ָI2Cģʽ
    I2C_InitTSturcture.I2C_DutyCycle = I2C_DutyCycle_16_9;  //ָʱռձ
    I2C_InitTSturcture.I2C_OwnAddress1 = address;  //ָI2C豸ַ
    I2C_InitTSturcture.I2C_Ack = I2C_Ack_Enable;   //ʹܻ߹رӦ (һ㶼ʹ)
    I2C_InitTSturcture.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit; //ַָĳ,7λ10λ
    I2C_Init( I2C1, &I2C_InitTSturcture);

    /* жϷʼ */
    NVIC_InitStructure.NVIC_IRQChannel = I2C1_EV_IRQn;  //¼ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;   //ռȼ
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    I2C_ITConfig( I2C1, I2C_IT_EVT, ENABLE);   //ʹ¼ж
    I2C_Cmd( I2C1, ENABLE);

}

void I2C1_EV_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void I2C1_EV_IRQHandler(void) {
    if (I2C_GetITStatus( I2C1, I2C_IT_ADDR) != RESET) {
        ((void) (I2C1->STAR1));
        ((void) (I2C1->STAR2));
    }
    if (I2C_GetITStatus( I2C1, I2C_IT_BTF) != RESET) {
        I2C_ReadRegister( I2C1, I2C_Register_STAR1);
        ((void) I2C1->DATAR);
    }
   if (I2C_GetITStatus( I2C1, I2C_IT_TXE) != RESET) {
        I2C_SendData( I2C1, TxData[slave_send_len]);
        slave_send_len++;
        if (slave_send_len == 7) {   //ߴжϣȻݣҲҪٵߴ
        //    slave_send_len = 0;
        }
        ((void) (I2C1->STAR1));
        ((void) (I2C1->STAR2));
    }
   if (I2C_GetITStatus( I2C1, I2C_IT_STOPF) != RESET) {
        I2C1->CTLR1 &= I2C1->CTLR1;
        ((void) (I2C1->STAR1));  //SR1Ĵ
    }
}

int main(void) {
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf("IIC Slave mode  \r\n");  //I2CΪӻʱ
    I2C1_Init(100000, RxAdderss);   //ӻʼ ʣ  ַ  SCL  SDA
    while(1)
    {
        if (slave_send_len == 7)   //ߴжϣȻݣҲҪٵߴ
        {
            printf( " TxData :" );
            for(u8 i=0; i<6; i++ )
            {
                printf( "%02x ", TxData[i] );  //  "%02x "  յ  һ
            }
            printf( " \n" );
            slave_send_len= 0;
        }
    }
}

